framework 27 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829
  1. #!/bin/sh -- # no runable script, just for vi
  2. # we all like colorful messages
  3. if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
  4. expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
  5. CERROR="" # red
  6. CWARNING="" # yellow
  7. CMSG="" # green
  8. CINFO="" # light blue
  9. CDEBUG="" # blue
  10. CNORMAL="" # default system console color
  11. CDONE="" # green
  12. CPASS="" # green
  13. CFAIL="" # red
  14. CCMD="" # pink
  15. fi
  16. msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
  17. msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
  18. msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
  19. msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
  20. msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
  21. msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
  22. msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
  23. msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
  24. msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
  25. msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
  26. msgtest() {
  27. while [ -n "$1" ]; do
  28. echo -n "${CINFO}$1${CCMD} " >&2;
  29. echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
  30. shift
  31. if [ -n "$1" ]; then shift; else break; fi
  32. done
  33. echo -n "…${CNORMAL} " >&2;
  34. }
  35. msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
  36. msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
  37. msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
  38. # enable / disable Debugging
  39. MSGLEVEL=${MSGLEVEL:-3}
  40. if [ $MSGLEVEL -le 0 ]; then
  41. msgdie() { true; }
  42. fi
  43. if [ $MSGLEVEL -le 1 ]; then
  44. msgwarn() { true; }
  45. msgnwarn() { true; }
  46. fi
  47. if [ $MSGLEVEL -le 2 ]; then
  48. msgmsg() { true; }
  49. msgnmsg() { true; }
  50. msgtest() { true; }
  51. msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
  52. msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
  53. if [ -n "$CFAIL" ]; then
  54. msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
  55. else
  56. msgfail() { echo -n " ###FAILED###" >&2; }
  57. fi
  58. fi
  59. if [ $MSGLEVEL -le 3 ]; then
  60. msginfo() { true; }
  61. msgninfo() { true; }
  62. fi
  63. if [ $MSGLEVEL -le 4 ]; then
  64. msgdebug() { true; }
  65. msgndebug() { true; }
  66. fi
  67. msgdone() {
  68. if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
  69. [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
  70. [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
  71. [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
  72. [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
  73. true;
  74. else
  75. echo "${CDONE}DONE${CNORMAL}" >&2;
  76. fi
  77. }
  78. runapt() {
  79. msgdebug "Executing: ${CCMD}$*${CDEBUG} "
  80. if [ -f ./aptconfig.conf ]; then
  81. APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  82. elif [ -f ../aptconfig.conf ]; then
  83. APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  84. else
  85. LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  86. fi
  87. }
  88. aptconfig() { runapt apt-config $*; }
  89. aptcache() { runapt apt-cache $*; }
  90. aptget() { runapt apt-get $*; }
  91. aptftparchive() { runapt apt-ftparchive $*; }
  92. aptkey() { runapt apt-key $*; }
  93. aptmark() { runapt apt-mark $*; }
  94. dpkg() {
  95. $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
  96. }
  97. aptitude() {
  98. if [ -f ./aptconfig.conf ]; then
  99. APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  100. elif [ -f ../aptconfig.conf ]; then
  101. APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  102. else
  103. LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  104. fi
  105. }
  106. addtrap() {
  107. CURRENTTRAP="$CURRENTTRAP $1"
  108. trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
  109. }
  110. setupenvironment() {
  111. TMPWORKINGDIRECTORY=$(mktemp -d)
  112. TESTDIRECTORY=$(readlink -f $(dirname $0))
  113. msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
  114. BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
  115. test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
  116. local OLDWORKINGDIRECTORY=$(pwd)
  117. addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
  118. cd $TMPWORKINGDIRECTORY
  119. mkdir rootdir aptarchive keys
  120. cd rootdir
  121. mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
  122. mkdir -p var/cache var/lib var/log
  123. mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
  124. touch var/lib/dpkg/available
  125. mkdir -p usr/lib/apt
  126. ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
  127. cd ..
  128. local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
  129. if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
  130. cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
  131. fi
  132. local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
  133. if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
  134. cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
  135. fi
  136. cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
  137. ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
  138. echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
  139. echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
  140. echo "Debug::NoLocking \"true\";" >> aptconfig.conf
  141. echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
  142. echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
  143. echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
  144. echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
  145. echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
  146. echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
  147. echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
  148. if ! $(which dpkg) --assert-multi-arch; then
  149. echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
  150. fi
  151. echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
  152. echo 'quiet::NoUpdate "true";' >> aptconfig.conf
  153. export LC_ALL=C
  154. export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
  155. msgdone "info"
  156. }
  157. getarchitecture() {
  158. if [ "$1" = "native" -o -z "$1" ]; then
  159. eval `aptconfig shell ARCH APT::Architecture`
  160. if [ -n "$ARCH" ]; then
  161. echo $ARCH
  162. else
  163. dpkg --print-architecture
  164. fi
  165. else
  166. echo $1
  167. fi
  168. }
  169. getarchitectures() {
  170. echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
  171. }
  172. configarchitecture() {
  173. local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
  174. rm -f $CONFFILE
  175. echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
  176. shift
  177. while [ -n "$1" ]; do
  178. echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
  179. shift
  180. done
  181. configdpkg
  182. }
  183. configdpkg() {
  184. if [ ! -e rootdir/var/lib/dpkg/status ]; then
  185. local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
  186. if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
  187. cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
  188. else
  189. echo -n > rootdir/var/lib/dpkg/status
  190. fi
  191. fi
  192. if $(which dpkg) --assert-multi-arch; then
  193. local ARCHS="$(getarchitectures)"
  194. if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
  195. DPKGARCH="$(dpkg --print-architecture)"
  196. for ARCH in ${ARCHS}; do
  197. if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
  198. done
  199. if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
  200. # dpkg doesn't really check the version as long as it is fully installed,
  201. # but just to be sure we choose one above the required version
  202. insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
  203. fi
  204. fi
  205. fi
  206. }
  207. setupsimplenativepackage() {
  208. local NAME="$1"
  209. local ARCH="$2"
  210. local VERSION="$3"
  211. local RELEASE="${4:-unstable}"
  212. local DEPENDENCIES="$5"
  213. local DESCRIPTION="$6"
  214. local SECTION="${7:-others}"
  215. local DISTSECTION
  216. if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
  217. DISTSECTION="main"
  218. else
  219. DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
  220. fi
  221. local BUILDDIR=incoming/${NAME}-${VERSION}
  222. mkdir -p ${BUILDDIR}/debian/source
  223. cd ${BUILDDIR}
  224. echo "* most suckless software product ever" > FEATURES
  225. test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
  226. test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
  227. * Initial release
  228. -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
  229. test -e debian/control || echo "Source: $NAME
  230. Section: $SECTION
  231. Priority: optional
  232. Maintainer: Joe Sixpack <joe@example.org>
  233. Build-Depends: debhelper (>= 7)
  234. Standards-Version: 3.9.1
  235. Package: $NAME" > debian/control
  236. if [ "$ARCH" = 'all' ]; then
  237. echo "Architecture: all" >> debian/control
  238. else
  239. echo "Architecture: any" >> debian/control
  240. fi
  241. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
  242. if [ -z "$DESCRIPTION" ]; then
  243. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  244. If you find such a package installed on your system,
  245. YOU did something horribly wrong! They are autogenerated
  246. und used only by testcases for APT and surf no other propose…" >> debian/control
  247. else
  248. echo "Description: $DESCRIPTION" >> debian/control
  249. fi
  250. test -e debian/compat || echo "7" > debian/compat
  251. test -e debian/source/format || echo "3.0 (native)" > debian/source/format
  252. test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
  253. cd - > /dev/null
  254. }
  255. buildsimplenativepackage() {
  256. local NAME="$1"
  257. local ARCH="$2"
  258. local VERSION="$3"
  259. local RELEASE="${4:-unstable}"
  260. local DEPENDENCIES="$5"
  261. local DESCRIPTION="$6"
  262. local SECTION="${7:-others}"
  263. local PRIORITY="${8:-optional}"
  264. local DISTSECTION
  265. if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
  266. DISTSECTION="main"
  267. else
  268. DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
  269. fi
  270. local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
  271. msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
  272. mkdir -p $BUILDDIR/debian/source
  273. echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
  274. echo "#!/bin/sh
  275. echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
  276. echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
  277. echo "$NAME ($VERSION) $RELEASE; urgency=low
  278. * Initial release
  279. -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
  280. echo "Source: $NAME
  281. Section: $SECTION
  282. Priority: $PRIORITY
  283. Maintainer: Joe Sixpack <joe@example.org>
  284. Standards-Version: 3.9.1
  285. Package: $NAME" > ${BUILDDIR}/debian/control
  286. if [ "$ARCH" = 'all' ]; then
  287. echo "Architecture: all" >> ${BUILDDIR}/debian/control
  288. else
  289. echo "Architecture: any" >> ${BUILDDIR}/debian/control
  290. fi
  291. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
  292. if [ -z "$DESCRIPTION" ]; then
  293. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  294. If you find such a package installed on your system,
  295. YOU did something horribly wrong! They are autogenerated
  296. und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
  297. else
  298. echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
  299. fi
  300. echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
  301. local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
  302. for SRC in $SRCS; do
  303. echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
  304. done
  305. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  306. rm -rf ${BUILDDIR}/debian/tmp
  307. mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
  308. cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
  309. cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
  310. (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
  311. (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
  312. dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
  313. echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
  314. done
  315. mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
  316. cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
  317. cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
  318. rm -rf "${BUILDDIR}"
  319. msgdone "info"
  320. }
  321. buildpackage() {
  322. local BUILDDIR=$1
  323. local RELEASE=$2
  324. local SECTION=$3
  325. local ARCH=$(getarchitecture $4)
  326. msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
  327. cd $BUILDDIR
  328. if [ "$ARCH" = "all" ]; then
  329. ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
  330. fi
  331. local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
  332. local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
  333. local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
  334. cd - > /dev/null
  335. for PKG in $PKGS; do
  336. echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
  337. done
  338. for SRC in $SRCS; do
  339. echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
  340. done
  341. msgdone "info"
  342. }
  343. buildaptarchive() {
  344. if [ -d incoming ]; then
  345. buildaptarchivefromincoming $*
  346. else
  347. buildaptarchivefromfiles $*
  348. fi
  349. }
  350. createaptftparchiveconfig() {
  351. local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
  352. if [ -z "$ARCHS" ]; then
  353. # the pool is empty, so we will operate on faked packages - let us use the configured archs
  354. ARCHS="$(getarchitectures)"
  355. fi
  356. echo -n 'Dir {
  357. ArchiveDir "' >> ftparchive.conf
  358. echo -n $(readlink -f .) >> ftparchive.conf
  359. echo -n '";
  360. CacheDir "' >> ftparchive.conf
  361. echo -n $(readlink -f ..) >> ftparchive.conf
  362. echo -n '";
  363. FileListDir "' >> ftparchive.conf
  364. echo -n $(readlink -f pool/) >> ftparchive.conf
  365. echo -n '";
  366. };
  367. Default {
  368. Packages::Compress ". gzip bzip2 lzma xz";
  369. Sources::Compress ". gzip bzip2 lzma xz";
  370. Contents::Compress ". gzip bzip2 lzma xz";
  371. Translation::Compress ". gzip bzip2 lzma xz";
  372. LongDescription "false";
  373. };
  374. TreeDefault {
  375. Directory "pool/";
  376. SrcDirectory "pool/";
  377. };
  378. APT {
  379. FTPArchive {
  380. Release {
  381. Origin "joesixpack";
  382. Label "apttestcases";
  383. Suite "unstable";
  384. Description "repository with dummy packages";
  385. Architectures "' >> ftparchive.conf
  386. echo -n "$ARCHS" >> ftparchive.conf
  387. echo 'source";
  388. };
  389. };
  390. };' >> ftparchive.conf
  391. for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
  392. echo -n 'tree "dists/' >> ftparchive.conf
  393. echo -n "$DIST" >> ftparchive.conf
  394. echo -n '" {
  395. Architectures "' >> ftparchive.conf
  396. echo -n "$ARCHS" >> ftparchive.conf
  397. echo -n 'source";
  398. FileList "' >> ftparchive.conf
  399. echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
  400. echo -n '";
  401. SourceFileList "' >> ftparchive.conf
  402. echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
  403. echo -n '";
  404. Sections "' >> ftparchive.conf
  405. echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
  406. echo '";
  407. };' >> ftparchive.conf
  408. done
  409. }
  410. buildaptftparchivedirectorystructure() {
  411. local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
  412. for DIST in $DISTS; do
  413. local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
  414. for SECTION in $SECTIONS; do
  415. local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
  416. for ARCH in $ARCHS; do
  417. mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
  418. done
  419. mkdir -p dists/${DIST}/${SECTION}/source
  420. mkdir -p dists/${DIST}/${SECTION}/i18n
  421. done
  422. done
  423. }
  424. insertpackage() {
  425. local RELEASE="$1"
  426. local NAME="$2"
  427. local ARCH="$3"
  428. local VERSION="$4"
  429. local DEPENDENCIES="$5"
  430. local PRIORITY="${6:-optional}"
  431. local ARCHS=""
  432. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  433. if [ "$arch" = "all" ]; then
  434. ARCHS="$(getarchitectures)"
  435. else
  436. ARCHS="$arch"
  437. fi
  438. for BUILDARCH in $ARCHS; do
  439. local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
  440. mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
  441. touch aptarchive/dists/${RELEASE}/main/source/Sources
  442. local FILE="${PPATH}/Packages"
  443. echo "Package: $NAME
  444. Priority: $PRIORITY
  445. Section: other
  446. Installed-Size: 42
  447. Maintainer: Joe Sixpack <joe@example.org>
  448. Architecture: $arch
  449. Version: $VERSION
  450. Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
  451. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  452. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  453. If you find such a package installed on your system,
  454. YOU did something horribly wrong! They are autogenerated
  455. und used only by testcases for APT and surf no other propose…
  456. " >> $FILE
  457. done
  458. done
  459. }
  460. insertsource() {
  461. local RELEASE="$1"
  462. local NAME="$2"
  463. local ARCH="$3"
  464. local VERSION="$4"
  465. local DEPENDENCIES="$5"
  466. local ARCHS=""
  467. local SPATH="aptarchive/dists/${RELEASE}/main/source"
  468. mkdir -p $SPATH
  469. local FILE="${SPATH}/Sources"
  470. echo "Package: $NAME
  471. Binary: $NAME
  472. Version: $VERSION
  473. Maintainer: Joe Sixpack <joe@example.org>
  474. Architecture: $ARCH" >> $FILE
  475. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  476. echo "Files:
  477. d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
  478. d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
  479. }
  480. insertinstalledpackage() {
  481. local NAME="$1"
  482. local ARCH="$2"
  483. local VERSION="$3"
  484. local DEPENDENCIES="$4"
  485. local PRIORITY="${5:-optional}"
  486. local FILE='rootdir/var/lib/dpkg/status'
  487. local INFO='rootdir/var/lib/dpkg/info'
  488. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  489. echo "Package: $NAME
  490. Status: install ok installed
  491. Priority: $PRIORITY
  492. Section: other
  493. Installed-Size: 42
  494. Maintainer: Joe Sixpack <joe@example.org>
  495. Architecture: $arch
  496. Version: $VERSION" >> $FILE
  497. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  498. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
  499. If you find such a package installed on your system,
  500. YOU did something horribly wrong! They are autogenerated
  501. und used only by testcases for APT and surf no other propose…
  502. " >> $FILE
  503. if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
  504. echo -n > ${INFO}/${NAME}:${arch}.list
  505. else
  506. echo -n > ${INFO}/${NAME}.list
  507. fi
  508. done
  509. }
  510. buildaptarchivefromincoming() {
  511. msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
  512. cd aptarchive
  513. [ -e pool ] || ln -s ../incoming pool
  514. [ -e ftparchive.conf ] || createaptftparchiveconfig
  515. [ -e dists ] || buildaptftparchivedirectorystructure
  516. msgninfo "\tGenerate Packages, Sources and Contents files… "
  517. aptftparchive -qq generate ftparchive.conf
  518. cd - > /dev/null
  519. msgdone "info"
  520. generatereleasefiles
  521. }
  522. buildaptarchivefromfiles() {
  523. msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
  524. find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
  525. msgninfo "\t${line} file… "
  526. cat ${line} | gzip > ${line}.gz
  527. cat ${line} | bzip2 > ${line}.bz2
  528. cat ${line} | xz --format=lzma > ${line}.lzma
  529. cat ${line} | xz > ${line}.xz
  530. msgdone "info"
  531. done
  532. generatereleasefiles
  533. }
  534. # can be overridden by testcases for their pleasure
  535. getcodenamefromsuite() { echo -n "$1"; }
  536. getreleaseversionfromsuite() { true; }
  537. getlabelfromsuite() { true; }
  538. generatereleasefiles() {
  539. # $1 is the Date header and $2 is the ValidUntil header to be set
  540. # both should be given in notation date/touch can understand
  541. msgninfo "\tGenerate Release files… "
  542. if [ -e aptarchive/dists ]; then
  543. for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
  544. local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
  545. local CODENAME="$(getcodenamefromsuite $SUITE)"
  546. local VERSION="$(getreleaseversionfromsuite $SUITE)"
  547. local LABEL="$(getlabelfromsuite $SUITE)"
  548. if [ -n "$VERSION" ]; then
  549. VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
  550. fi
  551. if [ -n "$LABEL" ]; then
  552. LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
  553. fi
  554. aptftparchive -qq release $dir \
  555. -o APT::FTPArchive::Release::Suite="${SUITE}" \
  556. -o APT::FTPArchive::Release::Codename="${CODENAME}" \
  557. ${LABEL} \
  558. ${VERSION} \
  559. | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
  560. if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
  561. sed -i '/^Date: / a\
  562. NotAutomatic: yes' $dir/Release
  563. fi
  564. if [ -n "$1" -a "$1" != "now" ]; then
  565. sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
  566. fi
  567. if [ -n "$2" ]; then
  568. sed -i "/^Date: / a\
  569. Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
  570. fi
  571. done
  572. else
  573. aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
  574. fi
  575. if [ -n "$1" -a "$1" != "now" ]; then
  576. for release in $(find ./aptarchive -name 'Release'); do
  577. touch -d "$1" $release
  578. done
  579. fi
  580. msgdone "info"
  581. }
  582. setupdistsaptarchive() {
  583. local APTARCHIVE=$(readlink -f ./aptarchive)
  584. rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
  585. rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
  586. for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
  587. SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
  588. msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
  589. echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
  590. echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
  591. msgdone "info"
  592. done
  593. }
  594. setupflataptarchive() {
  595. local APTARCHIVE=$(readlink -f ./aptarchive)
  596. if [ -f ${APTARCHIVE}/Packages ]; then
  597. msgninfo "\tadd deb sources.list line… "
  598. echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
  599. msgdone "info"
  600. else
  601. rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
  602. fi
  603. if [ -f ${APTARCHIVE}/Sources ]; then
  604. msgninfo "\tadd deb-src sources.list line… "
  605. echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
  606. msgdone "info"
  607. else
  608. rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
  609. fi
  610. }
  611. setupaptarchive() {
  612. buildaptarchive
  613. if [ -e aptarchive/dists ]; then
  614. setupdistsaptarchive
  615. else
  616. setupflataptarchive
  617. fi
  618. signreleasefiles
  619. msgninfo "\tSync APT's cache with the archive… "
  620. aptget update -qq
  621. msgdone "info"
  622. }
  623. signreleasefiles() {
  624. local SIGNER="${1:-Joe Sixpack}"
  625. msgninfo "\tSign archive with $SIGNER key… "
  626. local SECKEYS=""
  627. for KEY in $(find keys/ -name '*.sec'); do
  628. SECKEYS="$SECKEYS --secret-keyring $KEY"
  629. done
  630. local PUBKEYS=""
  631. for KEY in $(find keys/ -name '*.pub'); do
  632. PUBKEYS="$PUBKEYS --keyring $KEY"
  633. done
  634. for RELEASE in $(find aptarchive/ -name Release); do
  635. gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
  636. gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
  637. done
  638. msgdone "info"
  639. }
  640. changetowebserver() {
  641. if which weborf > /dev/null; then
  642. weborf -xb aptarchive/ 2>&1 > /dev/null &
  643. addtrap "kill $!;"
  644. elif which gatling > /dev/null; then
  645. cd aptarchive
  646. gatling -p 8080 -F -S 2>&1 > /dev/null &
  647. addtrap "kill $!;"
  648. cd - > /dev/null
  649. elif which lighttpd > /dev/null; then
  650. echo "server.document-root = \"$(readlink -f ./aptarchive)\"
  651. server.port = 8080
  652. server.stat-cache-engine = \"disable\"" > lighttpd.conf
  653. lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
  654. lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
  655. addtrap "kill $!;"
  656. else
  657. msgdie 'You have to install weborf or lighttpd first'
  658. return 1
  659. fi
  660. local APTARCHIVE="file://$(readlink -f ./aptarchive)"
  661. for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
  662. sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
  663. done
  664. return 0
  665. }
  666. checkdiff() {
  667. local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
  668. if [ -n "$DIFFTEXT" ]; then
  669. echo
  670. echo "$DIFFTEXT"
  671. return 1
  672. else
  673. return 0
  674. fi
  675. }
  676. testfileequal() {
  677. local FILE="$1"
  678. shift
  679. msgtest "Test for correctness of file" "$FILE"
  680. if [ -z "$*" ]; then
  681. echo -n "" | checkdiff $FILE - && msgpass || msgfail
  682. else
  683. echo "$*" | checkdiff $FILE - && msgpass || msgfail
  684. fi
  685. }
  686. testequal() {
  687. local COMPAREFILE=$(mktemp)
  688. addtrap "rm $COMPAREFILE;"
  689. echo "$1" > $COMPAREFILE
  690. shift
  691. msgtest "Test for equality of" "$*"
  692. $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  693. }
  694. testequalor2() {
  695. local COMPAREFILE1=$(mktemp)
  696. local COMPAREFILE2=$(mktemp)
  697. local COMPAREAGAINST=$(mktemp)
  698. addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
  699. echo "$1" > $COMPAREFILE1
  700. echo "$2" > $COMPAREFILE2
  701. shift 2
  702. msgtest "Test for equality OR of" "$*"
  703. $* 2>&1 1> $COMPAREAGAINST
  704. (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
  705. checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
  706. ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
  707. "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
  708. msgfail )
  709. }
  710. testshowvirtual() {
  711. local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
  712. local PACKAGE="$1"
  713. shift
  714. while [ -n "$1" ]; do
  715. VIRTUAL="${VIRTUAL}
  716. N: Can't select versions from package '$1' as it is purely virtual"
  717. PACKAGE="${PACKAGE} $1"
  718. shift
  719. done
  720. msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
  721. VIRTUAL="${VIRTUAL}
  722. N: No packages found"
  723. local COMPAREFILE=$(mktemp)
  724. addtrap "rm $COMPAREFILE;"
  725. local ARCH="$(getarchitecture 'native')"
  726. echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
  727. aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  728. }
  729. testnopackage() {
  730. msgtest "Test for non-existent packages" "apt-cache show $*"
  731. local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
  732. if [ -n "$SHOWPKG" ]; then
  733. echo
  734. echo "$SHOWPKG"
  735. msgfail
  736. return 1
  737. fi
  738. msgpass
  739. }
  740. testdpkginstalled() {
  741. msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
  742. local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
  743. if [ "$PKGS" != $# ]; then
  744. echo $PKGS
  745. dpkg -l $* | grep '^[a-z]'
  746. msgfail
  747. return 1
  748. fi
  749. msgpass
  750. }
  751. testdpkgnotinstalled() {
  752. msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
  753. local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
  754. if [ "$PKGS" != 0 ]; then
  755. echo
  756. dpkg -l $* | grep '^[a-z]'
  757. msgfail
  758. return 1
  759. fi
  760. msgpass
  761. }
  762. testmarkedauto() {
  763. local COMPAREFILE=$(mktemp)
  764. addtrap "rm $COMPAREFILE;"
  765. if [ -n "$1" ]; then
  766. msgtest 'Test for correctly marked as auto-installed' "$*"
  767. while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
  768. else
  769. msgtest 'Test for correctly marked as auto-installed' 'no package'
  770. echo -n > $COMPAREFILE
  771. fi
  772. aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  773. }
  774. pause() {
  775. echo "STOPPED execution. Press enter to continue"
  776. local IGNORE
  777. read IGNORE
  778. }